# coding: utf-8

"""
    VMware Aria Automation Pipelines APIs

    Aria Automation Pipelines is a continuous integration and continuous delivery (CICD) tool that you use to build Pipelines that model the software release process in your DevOps lifecycle. By creating Pipelines, you build the code infrastructure that delivers your software rapidly and continuously.  This page describes the RESTful APIs for Aria Automation Pipelines. The APIs facilitate CRUD operations on the various resources and entities used throughout Aria Automation Pipelines (Pipelines, Endpoints, Variables, etc.) and allow operations on them (executing a Pipeline, validating an Endpoint connection, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Aria Automation Pipelines entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/codestream/api/endpoints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/codestream/api/endpoints?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/codestream/api/endpoints?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /codestream/api/endpoints?$filter=startswith(name, 'ABC')     /codestream/api/endpoints?$filter=toupper(name) eq 'ABCD-JENKINS'     /codestream/api/endpoints?$filter=substringof(%27bc%27,tolower(name))     /codestream/api/endpoints?$filter=name eq 'ABCD' and project eq 'demo'   # noqa: E501

    OpenAPI spec version: 2019-10-17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Stage(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'tags': 'list[str]',
        'task_order': 'list[str]',
        'tasks': 'dict(str, Task1)'
    }

    attribute_map = {
        'description': 'description',
        'tags': 'tags',
        'task_order': 'taskOrder',
        'tasks': 'tasks'
    }

    def __init__(self, description=None, tags=None, task_order=None, tasks=None):  # noqa: E501
        """Stage - a model defined in Swagger"""  # noqa: E501
        self._description = None
        self._tags = None
        self._task_order = None
        self._tasks = None
        self.discriminator = None
        if description is not None:
            self.description = description
        if tags is not None:
            self.tags = tags
        if task_order is not None:
            self.task_order = task_order
        if tasks is not None:
            self.tasks = tasks

    @property
    def description(self):
        """Gets the description of this Stage.  # noqa: E501

        Stage description.  # noqa: E501

        :return: The description of this Stage.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Stage.

        Stage description.  # noqa: E501

        :param description: The description of this Stage.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def tags(self):
        """Gets the tags of this Stage.  # noqa: E501

        Tags are useful for ease in searching, grouping or filtering.  # noqa: E501

        :return: The tags of this Stage.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this Stage.

        Tags are useful for ease in searching, grouping or filtering.  # noqa: E501

        :param tags: The tags of this Stage.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def task_order(self):
        """Gets the task_order of this Stage.  # noqa: E501

        Order in which tasks will be executed.  # noqa: E501

        :return: The task_order of this Stage.  # noqa: E501
        :rtype: list[str]
        """
        return self._task_order

    @task_order.setter
    def task_order(self, task_order):
        """Sets the task_order of this Stage.

        Order in which tasks will be executed.  # noqa: E501

        :param task_order: The task_order of this Stage.  # noqa: E501
        :type: list[str]
        """

        self._task_order = task_order

    @property
    def tasks(self):
        """Gets the tasks of this Stage.  # noqa: E501

        Map representing details of various tasks present in the stage.  # noqa: E501

        :return: The tasks of this Stage.  # noqa: E501
        :rtype: dict(str, Task1)
        """
        return self._tasks

    @tasks.setter
    def tasks(self, tasks):
        """Sets the tasks of this Stage.

        Map representing details of various tasks present in the stage.  # noqa: E501

        :param tasks: The tasks of this Stage.  # noqa: E501
        :type: dict(str, Task1)
        """

        self._tasks = tasks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Stage, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Stage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
